# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_返利规则,2271,2271-4,sit,bs
主数据平台:后台运营系统返利规则查询接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取返利规则
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url3")
request_body = commonFuc().get_business_data(module, "payload3")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)


# 此函数用于当x为none时，进行空字符串替换
def func(x):
    if x is None:
        x = ""
        return x
    else:
        return x


# 生成一个随机数字，用于后续随机选择某一条返利规则
rebate_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取返利规则列表中某一条规则信息
rebate_name = result["data"]["list"][rebate_random]["rebatename"]
product_code = func(result["data"]["list"][rebate_random]["productcode"])
product_name = func(result["data"]["list"][rebate_random]["productname"])
customer_code = func(result["data"]["list"][rebate_random]["customercode"])
customer_name = func(result["data"]["list"][rebate_random]["customername"])
rebate_status = result["data"]["list"][rebate_random]["status"]
audit_statuss = result["data"]["list"][rebate_random]["auditstatus"]

# 第三步进行条件查询验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url4")
request_body = commonFuc().get_business_data(module, "payload4", rebate_name, product_code, product_name,
                                             customer_code, customer_name, rebate_status, audit_statuss)

"""
 场景: 验证返利使用明细列表查询条件是否可以正常使用
 用例名称：列表查询条件验证_返利使用明细
 输出：{"rebatename":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取查询结果中使用明细对应的客户编号
result = {"rebatename": result["data"]["list"][0]["rebatename"]}
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict4", rebate_name)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
