# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc停用_批量_特价单品,2264,2264-64,sit,bs
主数据平台:运营后台管理系统特价单品停用接口和导入接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
from common.db.db import mySql
import requests
import json
import os

module = "cmdc_special_fresenius_group"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers2", cmdc_access_token)

# 第二步特价单品列表查询
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url1")
request_body = commonFuc().get_business_data(module, "payload_1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取特价单品对应的商品信息和客户信息
product_code = result["data"]["list"][0]["freseniusProduct"]["productCode"]
product_name = result["data"]["list"][0]["freseniusProduct"]["productName"]
customer_code = result["data"]["list"][0]["customerCode"]
customer_name = result["data"]["list"][0]["customerName"]

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/按条件停用单品与客户关系.xlsx"

# 将商品信息和客户信息写入文件中
excel = HandleExcel(file_path, "Sheet1")
excel.write_data(row=2, column=1, value=product_code)
excel.write_data(row=2, column=2, value=product_name)
excel.write_data(row=2, column=3, value=customer_code)
excel.write_data(row=2, column=4, value=customer_name)

# 第二步文件导入
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url18")

request_body = commonFuc().get_business_data(module, "payload18_0")

# 获取文件
file = open(file_path, "rb")
files = {"file": file}
# 发送请求
result = requests.post(url, files=files, headers=headers, data=request_body)
result = json.loads(result.content)

# 导入成功后获取对应的套包id
group_id = result["data"]["freseniusAgreementPrices"][0]["groupId"]
fresenius_price_id = result["data"]["freseniusAgreementPrices"][0]["freseniusPriceId"]

# 第三步进行特价单品删除操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url_open")
request_body = {"freseniusPriceIds": [fresenius_price_id], "groupPriceStatus": 0, "remarks": "特价单品停用"}

"""
 场景:停用_批量_特价单品
 用例名称：停用_批量_特价单品
 输出：{"groupPriceStatus": 0}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
file.close()

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 数据库查询特价单品数量
sql = "SELECT t.groupPriceStatus FROM `cmdc-order`.tc_fresenius_agreement_price t WHERE groupId = {};".format(group_id)
result = {"groupPriceStatus": mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]}

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict19")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

